/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventGateway type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventGateway{}

// WebhookEventGateway struct for WebhookEventGateway
type WebhookEventGateway struct {
	Id string `json:"id"`
	MessengerId string `json:"messenger_id"`
	Provider Provider `json:"provider"`
	MessengerType Messenger `json:"messenger_type"`
}

// NewWebhookEventGateway instantiates a new WebhookEventGateway object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventGateway(id string, messengerId string, provider Provider, messengerType Messenger) *WebhookEventGateway {
	this := WebhookEventGateway{}
	this.Id = id
	this.MessengerId = messengerId
	this.Provider = provider
	this.MessengerType = messengerType
	return &this
}

// NewWebhookEventGatewayWithDefaults instantiates a new WebhookEventGateway object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventGatewayWithDefaults() *WebhookEventGateway {
	this := WebhookEventGateway{}
	return &this
}

// GetId returns the Id field value
func (o *WebhookEventGateway) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WebhookEventGateway) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WebhookEventGateway) SetId(v string) {
	o.Id = v
}

// GetMessengerId returns the MessengerId field value
func (o *WebhookEventGateway) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *WebhookEventGateway) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *WebhookEventGateway) SetMessengerId(v string) {
	o.MessengerId = v
}

// GetProvider returns the Provider field value
func (o *WebhookEventGateway) GetProvider() Provider {
	if o == nil {
		var ret Provider
		return ret
	}

	return o.Provider
}

// GetProviderOk returns a tuple with the Provider field value
// and a boolean to check if the value has been set.
func (o *WebhookEventGateway) GetProviderOk() (*Provider, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Provider, true
}

// SetProvider sets field value
func (o *WebhookEventGateway) SetProvider(v Provider) {
	o.Provider = v
}

// GetMessengerType returns the MessengerType field value
func (o *WebhookEventGateway) GetMessengerType() Messenger {
	if o == nil {
		var ret Messenger
		return ret
	}

	return o.MessengerType
}

// GetMessengerTypeOk returns a tuple with the MessengerType field value
// and a boolean to check if the value has been set.
func (o *WebhookEventGateway) GetMessengerTypeOk() (*Messenger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerType, true
}

// SetMessengerType sets field value
func (o *WebhookEventGateway) SetMessengerType(v Messenger) {
	o.MessengerType = v
}

func (o WebhookEventGateway) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventGateway) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["messenger_id"] = o.MessengerId
	toSerialize["provider"] = o.Provider
	toSerialize["messenger_type"] = o.MessengerType
	return toSerialize, nil
}

type NullableWebhookEventGateway struct {
	value *WebhookEventGateway
	isSet bool
}

func (v NullableWebhookEventGateway) Get() *WebhookEventGateway {
	return v.value
}

func (v *NullableWebhookEventGateway) Set(val *WebhookEventGateway) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventGateway) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventGateway) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventGateway(val *WebhookEventGateway) *NullableWebhookEventGateway {
	return &NullableWebhookEventGateway{value: val, isSet: true}
}

func (v NullableWebhookEventGateway) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventGateway) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


